
architecture trigdly of trig_delay_gen is 
			   
signal counterreset_int, dlytrigger_int : std_logic;
 
begin  


TRIG_DELAY_LOGIC: process (CLK160, TRIGIN, TRIG_DELAY)
variable delaycount, tmpdly : std_logic_vector ((buswidth-1) downto 0);
variable enablecount, counterreset, dlytrigger : std_logic := '0';
 
begin

    if(CLK160'event and CLK160='1') then

      if (LD_DATA ='1') then
       
           delaycount :=  TRIG_DELAY;
		   tmpdly := TRIG_DELAY;

       end if;
   end if;

   if (TRIGIN'event and TRIGIN='1') then
        enablecount := '1';
        counterreset := '1';
		delaycount := tmpdly;
   end if;

   if(CLK160'event) then


   if (enablecount = '1'and delaycount > "00000000000000000000000000000000") then
        counterreset := '0';
        delaycount := delaycount - 1;
        dlytrigger := '0';

     end if;
      
    if (delaycount = "00000000000000000000000000000000") then
         enablecount := '0';
        dlytrigger := '1';

    end if;

    end if;


	dlytrigger_int <= dlytrigger;
    counterreset_int <= counterreset;

end process TRIG_DELAY_LOGIC;

--Master Counter

MCOUNTER : process (CLK160, counterreset_int, dlytrigger_int, HOLD_COUNT)

variable countup : std_logic_vector ((buswidth-1) downto 0);
variable trigdetect : boolean;

begin

  if (counterreset_int = '1') then
     countup := "00000000000000000000000000000000";
    trigdetect :=FALSE;
  end if;

  if (dlytrigger_int'event and dlytrigger_int ='1') then  -- trigger detected
    trigdetect :=TRUE;
  end if;

   if (CLK160'event and CLK160 ='1') then

     if (trigdetect = TRUE) then
      countup := countup + 1;
   
      if (countup <= HOLD_COUNT) then
        DLYD_TRIGGER <= '1';
      else
        DLYD_TRIGGER <= '0';
      end if;
     
     end if;

   end if;

   MCOUNT <= countup;

end process MCOUNTER;


end trigdly; 
